SystemOrganization addCategory: #'Prolog-Dungeon'!


Prolog subclass: #Dungeon
	instanceVariableNames: 'pen aspect snoopy delay arcs nodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Dungeon'!

Dungeon class
	instanceVariableNames: ''!

PolygonMorph subclass: #WanderingDogMorph
	instanceVariableNames: 'destinations speed stepTime lastDestination'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Dungeon'!

WanderingDogMorph class
	instanceVariableNames: ''!

Object subclass: #DogStep
	instanceVariableNames: 'destination speed forwardDirection isAbsolute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Prolog-Dungeon'!

DogStep class
	instanceVariableNames: ''!


!Dungeon commentStamp: 'bolot 12/13/2002 16:00' prior: 0!
Incomplete

ISSUE: Animation
Smalltalk/V uses a slightly different approach.
We'll either adopt it, or use Morphic.

ISSUE: Stack size limit
A few methods didn't compile (and have big portions commented out)

ISSUE: Bugs
An ongoing attempt to rewrite this example is incomplete.
!
]style[(279)!

!WanderingDogMorph commentStamp: 'bolot 12/15/2002 03:13' prior: 0!
WanderingDogMorph - used for animating Dungeons demo



self openInWorld
self stop
self start
self position: 10@100
self position
self addFlexShellIfNecessary 
self owner position
self position: 10@10
self goto: 300@500
self owner delete
self stepTime: 100
TransformationMorph 
self player
moveToward:
self isFlexed 
self referencePosition bearingToPoint: 10@100
self referencePosition
!
]style[(386)!

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 02:33'!
addDestination: aPoint
	destinations add: aPoint.! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:19'!
defaultHopSpeed
	^15! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:19'!
defaultSpeed
	^15! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 03:23'!
delete
	| currOwner |
	self isFlexed
		ifTrue: [currOwner := self owner. super delete. currOwner delete]
		ifFalse: [super delete].! !

!WanderingDogMorph class methodsFor: 'instance creation' stamp: 'bolot 12/15/2002 17:00'!
dogShapeVertices
	"this is a large dog, use (array/4) rounded to get a smaller one"
	^{195@30. 237@44. 230@61. 200@56. 212@72. 188@63. 171@101. 184@162. 150@111. 120@172. 126@107. 46@110. 56@165. 30@124. 0@159. 18@64. 7@4. 35@48. 141@51. 170@18. 173@0. 181@11. 195@2. 195@30}! !

!DogStep class methodsFor: 'instance creation' stamp: 'bolot 12/15/2002 17:41'!
fall: aHeight
	^self new fall: aHeight; yourself! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:15'!
fall: aHeight
	"relative"
	self fall: aHeight from: 0@0.
	isAbsolute := false.! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:05'!
fall: aHeight
	| lastStep |
	lastStep := destinations isEmpty ifTrue: [lastDestination] ifFalse: [destinations last].
	self addDestination: (DogStep fall: aHeight from: lastStep getDestination)! !

!DogStep class methodsFor: 'instance creation' stamp: 'bolot 12/15/2002 18:03'!
fall: aHeight from: aStartPoint
	^self new fall: aHeight from: aStartPoint; yourself! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:15'!
fall: aHeight from: aStartPoint
	"relative"
	destination := aStartPoint + (0@aHeight).
	speed := self defaultHopSpeed.
	forwardDirection := 180.
	isAbsolute := true.! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:46'!
getDestination
	^destination! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:45'!
getForwardDirection
	^forwardDirection! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:45'!
getSpeed
	^speed! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 02:33'!
getSpeed
	^speed! !

!DogStep class methodsFor: 'instance creation' stamp: 'bolot 12/15/2002 17:42'!
go: aPoint
	^self new go: aPoint; yourself! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:12'!
go: aPoint
	"relative"
	destination := aPoint.
	speed := self defaultSpeed.
	forwardDirection := 90.
	isAbsolute := false.! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:18'!
go: aPoint
	| lastStep |
	lastStep := destinations isEmpty ifTrue: [lastDestination] ifFalse: [destinations last].
	self addDestination: (DogStep goto: aPoint + lastStep getDestination)! !

!DogStep class methodsFor: 'instance creation' stamp: 'bolot 12/15/2002 17:41'!
goto: aPoint
	^self new goto: aPoint; yourself! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:12'!
goto: aPoint
	"absolute"
	destination := aPoint.
	speed := self defaultSpeed.
	forwardDirection := 90.
	isAbsolute := true.! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:42'!
goto: aPoint
"Transcript show: 'going to: ', aPoint asString; cr."
	self addDestination: (DogStep goto: aPoint)! !

!DogStep class methodsFor: 'instance creation' stamp: 'bolot 12/15/2002 17:43'!
goto: aPoint speed: aSpeed
	^self new goto: aPoint speed: aSpeed; yourself! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:42'!
goto: aPoint speed: aSpeed
	"absolute"
	destination := aPoint.
	speed := aSpeed.
	forwardDirection := 90.
	isAbsolute := true.! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:43'!
goto: aPoint speed: aNumber
"Transcript show: 'going to: ', aPoint asString; cr."
	self addDestination: (DogStep goto: aPoint speed: aNumber)! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:50'!
hop: aHeight
	self jump: aHeight.
	self fall: aHeight.! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:48'!
initialize
	super initialize.
	destinations := OrderedCollection new.
	Player new costume: self.
	speed := 5.
	lastDestination := DogStep goto: self position.! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:37'!
isAbsolute
	^isAbsolute == true! !

!DogStep class methodsFor: 'instance creation' stamp: 'bolot 12/15/2002 17:41'!
jump: aHeight
	^self new jump: aHeight; yourself! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:15'!
jump: aHeight
	"relative"
	self jump: aHeight from: 0@0.
	isAbsolute := false.! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:04'!
jump: aHeight
	| lastStep |
	lastStep := destinations isEmpty ifTrue: [lastDestination] ifFalse: [destinations last].
	self addDestination: (DogStep jump: aHeight from: lastStep getDestination)! !

!DogStep class methodsFor: 'instance creation' stamp: 'bolot 12/15/2002 18:03'!
jump: aHeight from: aStartPoint
	^self new jump: aHeight from: aStartPoint; yourself! !

!DogStep methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:15'!
jump: aHeight from: aStartPoint
	"relative"
	destination := aStartPoint - (0@aHeight).
	speed := self defaultHopSpeed.
	forwardDirection := 0.
	isAbsolute := true.! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 10/11/2022 10:35'!
logicAdjust

"Adjust the y coordinate by Aspect ratio."
adjust(Result, Y) :-
    iss(Result, (y logicValue * aspect) truncated).! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 10/4/2022 00:15'!
logicAvoid

"Fail if room is one of roomsToAvoid and
 go back to previousRoom. Else succeed."

avoid(Room,RoomsToAvoid,PreviousRoom) :-
	member(Room,RoomsToAvoid),
	goto(PreviousRoom), !!, fail().

avoid(:=,:=,:=).! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 11/18/2009 18:09'!
logicDraw

"Draw a map of the dungeon."
draw() :- drawArc(), fail().
draw() :- drawNode(), fail().
draw(). ! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 10/11/2022 10:35'!
logicDrawArc

drawArc() :- gallery(X, Y),
	position(X, A, B),
	position(Y, C, D),
	iss(:=, arcs add: (PolygonMorph vertices: {a logicValue @ b logicValue. c logicValue @ d logicValue}
			color: Color black borderWidth: 2 borderColor: Color black)),
	iss(:=, World addMorph: arcs last behind: snoopy).! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 10/13/2022 00:37'!
logicDrawNode

"Call a Smalltalk method to draw a room."
drawNode() :-
	position(X, A, B),
	"iss(:=, x logicValue displayAt: a logicValue @ b logicValue),"
	iss(:=, nodes add: (SimpleButtonMorph new label: x logicValue)),
	iss(:=, nodes last position: (a logicValue - 20) @ (b logicValue - 10)),
	iss(:=, World addMorph: nodes last behind: snoopy).! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 10/4/2022 00:17'!
logicGallery

"Define database of all connecting rooms."
gallery(entry,monsters).
gallery(entry,stadium).
gallery(stadium,hell).
gallery(stadium,dolphin).
gallery(stadium,pond).
gallery(exit,gold).
gallery(robbers,gold).
gallery(stadium,robbers).
gallery(pond,gold).
gallery(dolphin,exit).
gallery(monsters,gold).! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 10/11/2022 10:35'!
logicGo

"Move from a room here to a room there."
go() :-
	initialize(),
	draw(),
	"iss(:=, self halt),"
	route(entry,exit,[entry]).! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 10/11/2022 10:35'!
logicGoto

goto(NextRoom) :-
	position(NextRoom, X, Y),
	iss(:=, snoopy goto: x logicValue @ (y logicValue)).
	"iss(:=, snoopy position: x logicValue - 30 @ (y logicValue - 25)),"
	"iss(:=, Transcript show: '')," "to force morphs to appear"
	"iss(:=, delay wait)."! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 10/4/2022 00:18'!
logicGotoAndAvoid

gotoAndAvoid(Room,RoomsToAvoid,PreviousRoom) :-
	goto(Room),
	avoid(Room,RoomsToAvoid,PreviousRoom).
gotoAndAvoid(:=,:=,:=).! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 10/4/2022 00:20'!
logicIsFinished

"Check if adventure is succeeded."
isFinished(VisitedRooms) :-
	member(gold,VisitedRooms),
	end().
isFinished([:=, X | :=]) :-
	goto(X), !!, fail().! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 10/4/2022 00:21'!
logicNeighborroom

"Unify the next neighbor room of X with Y."

neighborroom(X,Y,VisitedRooms) :-
	or(gallery(X,Y), gallery(Y,X)).

neighborroom(:=,:=,[:= , X | :=]) :-
	goto(X), !!, fail().! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 10/4/2022 00:23'!
logicPosition

"Define the position of each room on screen."

position(entry,40,Y) :- adjust(Y, 80).
position(stadium,230,Y) :- adjust(Y, 50).
position(monsters,40,Y) :- adjust(Y, 200).
position(hell,90,Y) :- adjust(Y, 310).
position(pond,330,Y) :- adjust(Y, 160).
position(gold,460,Y) :- adjust(Y, 200).
position(dolphin,380,Y) :- adjust(Y, 70).
position(robbers,230,Y) :- adjust(Y, 310).
position(exit,580,Y) :- adjust(Y, 180).! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 10/4/2022 00:26'!
logicRoute

"Find the route to the next room avoiding
 dangerous or visited rooms."

route(exit,exit,VisitedRooms) :-
	isFinished(VisitedRooms).

route(exit,:=,:=).

route(Room,WayOut,VisitedRooms) :-
	not(=(Room, exit)),
	neighborroom(Room,NextRoom,VisitedRooms),
	not(member(NextRoom,VisitedRooms)),
	goto(NextRoom),
	avoid(NextRoom,[monsters, robbers],Room),
	route(NextRoom,WayOut,[NextRoom|VisitedRooms]).! !

!WanderingDogMorph class methodsFor: 'instance creation' stamp: 'bolot 12/15/2002 17:24'!
newSnoopyDog
	^self new
		vertices: (self dogShapeVertices / 4) rounded
			color: Color white
			borderWidth: 2 borderColor: Color black;
		makeClosed;
		setSpeed: 10;
		forwardDirection: 90;
		yourself! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 9/26/2022 13:22'!
primlogicEnd: assoc
	"End the whole thing.  This method
	does not return.  It restarts the Scheduler."
	3 timesRepeat: [snoopy hop: 100].
	snoopy go: 100@0.
	snoopy go: -200@0.
	snoopy go: 100@0.
	PopUpMenu notify: 'Click OK when animation is over'.
	snoopy delete.
"	snoopy := nil."
	arcs , nodes do: [:morph | morph delete].
	arcs := nodes := nil.
	Display restore.
"	self inform: 'Gold is found, close this window'."
	"Scheduler resume"! !

!Dungeon methodsFor: 'as yet unclassified' stamp: 'spfa 10/4/2022 00:24'!
primlogicInitialize: assoc
	"This is a Smalltalk method, but can be called as
	a Prolog/V predicate.  It initializes instance
	variables and gray the screen.  The animal moving
	speed is also initialized here."

	snoopy := WanderingDogMorph newSnoopyDog.
	snoopy openInWorld.
	arcs := OrderedCollection new.
	nodes := OrderedCollection new.
	"delay := Delay forSeconds: 1."
	"pen := PenPointRecorder new defaultNib: 2."
	aspect := 1.
	^assoc value! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 17:12'!
setSpeed: aNumber
	speed := aNumber! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 18:20'!
step
	| nextPoint nextStep angle alterEgo |
	super step.
	destinations isEmptyOrNil ifTrue: [^self].
	nextStep := destinations first.
	self setSpeed: nextStep getSpeed.
	nextPoint := nextStep getDestination.
	nextStep isAbsolute ifFalse: [nextPoint := nextPoint + lastDestination getDestination].
	"nextStep getForwardDirection = self forwardDirection
		ifFalse: [self forwardDirection: nextStep getForwardDirection]."

	self isFlexed ifTrue: [alterEgo := self owner] ifFalse: [alterEgo := self].
	"alterEgo := self owner."

	((alterEgo referencePosition - nextPoint) r < (2*self getSpeed))
		ifTrue: [lastDestination := destinations removeFirst].
	angle := alterEgo referencePosition bearingToPoint: nextPoint.
	self player setHeading: angle.
	self player forward: self getSpeed.! !

!WanderingDogMorph methodsFor: 'as yet unclassified' stamp: 'bolot 12/15/2002 02:47'!
stop
	super stop.
	destinations := OrderedCollection new! !
